/*
 * wysmod - lcd.c
 * 	version 0.0.0
 * 
 * Copyright (C) 2006  Marek Piwonski <marek@podlesie.net>
 * Copyright (C) 2006..2009  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/kernel.h>
#include <tmos/lcd.h>
#include <tmos/console.h>
#include <tmos/jiffies.h>
#include <asm/8051.h>
#include <asm/processor.h>

#define ROZK_NBUSY 		0x00
#define ROZK_BUSY		0x01
#define	DANA_BUSY 		0x03
#define	DANA_NBUSY 		0x02

#define	D_CLEAR	 		0x01
#define	HOME 		 	0x02
#define	ENTRY_MOD		0x06
#define	D_CONTROL		0x0c
#define	D_C_SHIFT		0x14
#define	FUNCT_SET		0x38
#define	D_ADDR_SET		0x80

static void lcd_rozkaz(char dana, char tryb)
{
	if (tryb & 0x01) {
		P2_2 = 0;
		P0 = 0xff;
		P2_0 = 0;
		P2_1 = 1;
		P2_2 = 1;
		while (P0_7)
			cpu_relax();
	}
	P2_2 = 0;
	P0 = dana;
	P2_0 = 0;
	if (tryb & 0x2)
		P2_0 = 1;
	P2_1 = 0;
	P2_2 = 1;
	P2_2 = 0;
}

void console_init(void)
{
	lcd_rozkaz(0x30, ROZK_NBUSY);
	usleep(2000);
	lcd_rozkaz(0x30, ROZK_NBUSY);
	lcd_rozkaz(FUNCT_SET, ROZK_BUSY);
	lcd_rozkaz(ENTRY_MOD, ROZK_BUSY);
	lcd_rozkaz(D_CONTROL, ROZK_BUSY);
	lcd_rozkaz(D_CLEAR, ROZK_BUSY);
}

void c_putchar_p(char pos, char c)
{
	if (pos >= 20)
		pos += 44;
	pos |= D_ADDR_SET; 
	lcd_rozkaz(pos, ROZK_BUSY);
	lcd_rozkaz(c, DANA_BUSY);
}

device_initcall(console_init)
